

/*
FOTO MUX
AVR 90S2313
------------------------------------------------------------------------------
 Programmed by Christof Ermer
26.07.2019
------------------------------------------------------------------------------

L:\LabViews_Labore\LV10_FotoDiodeMUX_Selector
L:\LabViews_Labore\LV15_FotoDiodeMUX_Selector\FotoMUXAmpSelector.vi


LOW 0xFF
AVRDUDE arguments
0x
FF
*	 
-U lfuse:w:0xff:m

FUSE 8MHz WDT / BrownOut -->  L=0x  H=0x
http://www.engbedded.com/fusecalc

avrdude -p at90s2313 -P usb   -c USBasp    -U flash:w:main.hex 
avrdude.conf -p at2313 -P /dev/parport0 -c USBasp  
-U flash:w:B:\Drive\NASDrive\AVR_Projekte\AA_AVR_PRJ_2021\ATT90S2313_AnaMUX\main.hex:a 
FUSE Default 0xFF
 values on the left side, or load factory default values for the selected device.
// Short Start Time  Enabled , SPI Enable

Lange Anlaufzeit;#
-U lfuse:w:0xDF:
 UNBEDINGE FUSE AUF xDF STELLEN, NICHT DE  DE=SHort STart Time !

Kurze Anlaufzeit:
-U lfuse:w:0xDE:
 UNBEDINGE FUSE AUF xDF STELLEN, NICHT DE  DE=SHort STart Time !


https://www.engbedded.com/fusecalc/
https://eleccelerator.com/fusecalc/fusecalc.php?chip=at90s2313
*/

// http://www.engbedded.com/fusecalc
// http://eleccelerator.com/fusecalc/fusecalc.php?chip=at90s2313
// http://www.engbedded.com/fusecalc/
//SYSINFO
#define DATUM		"06.11,2024"  //26.07.2019"
#define FUNKTION	"Analog MUX FotoAmp"
#define HARDWARE	"Atmel 90S2313"
#define AUTOR		"Christof Ermer"

/*  HISTORY 
*/
#include "main.h"		//with Hardware assigns

volatile uint8_t gu8Status;
volatile uint32_t gu32_Ticks;

ISR( TIMER0_OVF0_vect )
{
gu32_Ticks++;
if( !(gu32_Ticks & TICK_1000MS) ) //128-1 = 0x7F
	{
	gu8Status |= TICK_EVENT;
	};
/*	
if( !(gu32_Ticks & 0x04) ) //122 / 4 = 30 * /Sekunde
	{
	UART_TXRX_Check();		
	};
*/	
};
	
/*
definieren 	wdt_reset () __asm__ __volatile__ ("wdr")
#definieren 	wdt_enable (Wert)
#definieren 	wdt_disable ()
#definieren 	WDTO_15MS    0
#definieren 	WDTO_30MS    1
#definieren 	WDTO_60MS    2
#definieren 	WDTO_120MS    3
#definieren 	WDTO_250MS    4
#definieren 	WDTO_500MS    5
#definieren 	WDTO_1S    6
#definieren 	WDTO_2S    7
#definieren 	WDTO_4S    8
#definieren 	WDTO_8S    9
*/

// *******************************************************************
int main(void)
// *******************************************************************
{
//uint8_t u8NN=0;
wdt_enable(WDTO_1S);
wdt_reset();   //WATCHDOG	

DDRB = MUX_ADR_BITS | MUX_ENA_BIT; // Alle MUX LED EIN/Ausgnge
DDRD = 0x02 | FUNKTION_LED_BIT; //tx
//PORTD = 0x03;  //TX/RX

ResetRxBuff();
uart_init( UART_BAUD_SELECT( 9600, F_CPU)  );
sei(); 
		
FUNKT_LED_ON();
ENABLE_ON();
MUX_PORT = 0x02; // 3.te auswahl

uart_puts_p( PSTR("MUXBaud :9600\r") );

//Timer 0 = Sekunden TICK
TIMSK = (1<< TOIE0);
TCCR0 = (1<< CS02 ); // 816 / 256 / 256 =  122,87... 
gu8Status = 0;
wdt_enable(WDTO_1S);
while( 1 )
	{
	sei();
	wdt_reset();   //WATCHDOG	
	ENABLE_ON();
	if( gu8Status & TICK_EVENT )
		{
		gu8Status &= ~TICK_EVENT;
		FUNKT_LED_TOOGLE();
		if( gu8Status & TICK_TRAFFIC ) 
			{
			uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
			uart_putc( 13 ); //CR
			};
		};
	UART_TXRX_Check();				
	};// while
};
