

#ifndef MAIN_HEADER  //Prevents multiple includes
	#define MAIN_HEADER

#define UART_USE_ENABLED
//#define ADC_USED_ENABLED

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <string.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
//#include <compat\deprecated.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns
//#include "debug.h"
#include "uart.h"
#include "Befehle.h"

//PORT_ASSIGMNEMTS

#define TICK_1000MS 0x7F //(128-1) Statt Modulo % 128 ( 128-1=0x7F )

#define TWO_CLK_CYCLES() __asm__ __volatile__( "rjmp 1f\n 1:" );

#define MUX_DDRX		DDRB
#define MUX_PORT		PORTB
#define MUX_ADR_BITS	0x07
#define MUX_ENA_BIT		0x08 //ENABLE_PIN		PB3
#define ENABLE_PORT		PORTB
#define ENABLE_ON()		(ENABLE_PORT |=  MUX_ENA_BIT)
#define ENABLE_OFF()	(ENABLE_PORT &= ~ MUX_ENA_BIT)

#define FUNKTION_LED_BIT	0x40 //FUNKTION_LED_PIN	PD6
#define FUNKTION_LED_PORT	PORTD
#define FUNKT_LED_ON()	(FUNKTION_LED_PORT |= FUNKTION_LED_BIT)
#define FUNKT_LED_OFF()	(FUNKTION_LED_PORT &= ~FUNKTION_LED_BIT)
#define FUNKT_LED_TOOGLE()	(FUNKTION_LED_PORT ^= FUNKTION_LED_BIT)



#define TICK_EVENT 		0x01
#define UART_RX_EVENT	0x02
#define TICK_TRAFFIC	0x04
//uint8_t gu8Status;

extern volatile uint32_t gu32_Ticks; //T2
extern volatile uint8_t gu8Status;
#endif  //MAIN_HEADER
